unit mckBAPTrayIcon;

interface

uses
  Windows, Messages, Classes, Controls, mirror, mckCtrls, KOL, Graphics, KOLBAPTrayIcon;

type

  TKOLBAPTrayIcon = class(TKOLObj)
  private
    fToolTip: String;
    fOnBalloonShow: TOnEvent;
    fOnBalloonHide: TOnEvent;
    fOnBalloonClick: TOnEvent;
    fOnBalloonTimeOut: TOnEvent;
    fOnMouseMove: TOnMouse;
    fOnMouseDown: TOnMouse;
    fOnMouseUp: TOnMouse;
    fOnMouseDblClk: TOnMouse;
    procedure SetOnBalloonShow(Value: TOnEvent);
    procedure SetOnBalloonHide(Value: TOnEvent);
    procedure SetOnBalloonTimeOut(Value: TOnEvent);
    procedure SetOnBalloonClick(Value: TOnEvent);
    procedure SetOnMouseMove(Value: TOnMouse);
    procedure SetOnMouseDown(Value: TOnMouse);
    procedure SetOnMouseUp(Value: TOnMouse);
    procedure SetOnMouseDblClk(Value: TOnMouse);
    procedure SetToolTip(Value: String);

  protected
    function AdditionalUnits: String; override;
    procedure AssignEvents(SL: TStringList; const AName: String); override;
    procedure SetupFirst(SL: TStringList; const AName, AParent, Prefix: String); override;

  public
    constructor Create(Owner: TComponent); override;

  published
    property ToolTip: String read fToolTip write SetToolTip;
    property OnBalloonShow: TOnEvent read fOnBalloonShow write SetOnBalloonShow;
    property OnBalloonHide: TOnEvent read fOnBalloonHide write SetOnBalloonHide;
    property OnBalloonClick: TOnEvent read fOnBalloonClick write SetOnBalloonClick;
    property OnBalloonTimeOut: TOnEvent read fOnBalloonTimeOut write SetOnBalloonTimeOut;
    property OnMouseMove: TOnMouse read fOnMouseMove write SetOnMouseMove;
    property OnMouseDown: TOnMouse read fOnMouseDown write SetOnMouseDown;
    property OnMouseUp: TOnMouse read fOnMouseUp write SetOnMouseUp;
    property OnMouseDblClk: TOnMouse read fOnMouseDblClk write SetOnMouseDblClk;
  end;

procedure Register;

{$R *.dcr}

implementation

procedure Register;
begin
  RegisterComponents('KOL System', [TKOLBAPTrayIcon]);
end;

{   }
function TKOLBAPTrayIcon.AdditionalUnits;
begin
  Result := ', KOLBAPTrayIcon';
end;
////////////////////////////////////////////////////////////////////////////////

{--------------------------}
{   }
{--------------------------}
procedure TKOLBAPTrayIcon.AssignEvents;
begin
inherited;
  DoAssignEvents(SL, AName,
    ['OnBalloonShow', 'OnBalloonHide', 'OnBalloonTimeOut', 'OnBalloonClick'],
    [@OnBalloonShow,  @OnBalloonHide,  @OnBalloonTimeOut,  @OnBalloonClick]);

  DoAssignEvents(SL, AName,
    ['OnMouseMove', 'OnMouseDown', 'OnMouseUp', 'OnMouseDblClk'],
    [@OnMouseMove,  @OnMouseDown,  @OnMouseUp,  @OnMouseDblClk]);
end;

{--------------------------}
{   unitX_X.inc }
{--------------------------}
procedure TKOLBAPTrayIcon.SetupFirst;
begin
  SL.Add(Prefix + AName + ' := NewBAPTrayIcon( Result.Form );');

  if ToolTip <> '' then
    SL.Add(Prefix + AName + '.ToolTip := ''' + ToolTip + ''';');
end;
////////////////////////////////////////////////////////////////////////////////

{-------------}
{  }
{-------------}
constructor TKOLBAPTrayIcon.Create;
begin
inherited;
  fToolTip := '';
end;

procedure TKOLBAPTrayIcon.SetToolTip;
begin
  fToolTip := Value;
  Change;
end;

procedure TKOLBAPTrayIcon.SetOnBalloonShow;
begin
  fOnBalloonShow := Value;
  Change;
end;

procedure TKOLBAPTrayIcon.SetOnBalloonHide;
begin
  fOnBalloonHide := Value;
  Change;
end;

procedure TKOLBAPTrayIcon.SetOnBalloonClick;
begin
  fOnBalloonClick := Value;
  Change;
end;

procedure TKOLBAPTrayIcon.SetOnBalloonTimeOut;
begin
  fOnBalloonTimeOut := Value;
  Change;
end;

procedure TKOLBAPTrayIcon.SetOnMouseMove;
begin
  fOnMouseMove := Value;
  Change;
end;

procedure TKOLBAPTrayIcon.SetOnMouseDown;
begin
  fOnMouseDown := Value;
  Change;
end;

procedure TKOLBAPTrayIcon.SetOnMouseUp;
begin
  fOnMouseUp := Value;
  Change;
end;

procedure TKOLBAPTrayIcon.SetOnMouseDblClk;
begin
  fOnMouseDblClk := Value;
  Change;
end;

end.